<?php
include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsTransports.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/divers.php");

class ForfaitZoneQuantite extends PluginsTransports
{
	function ForfaitZoneQuantite()
    {
		$this->PluginsTransports("forfaitzonequantite");
	}
	
	// DB utils
	function escape($value)
    {
        if(get_magic_quotes_gpc()) $value = stripslashes($value);
        
        return mysql_real_escape_string($value);
    }
    
    function query($query, $die = 1)
    {
        $result = mysql_query($query);
    
        if ($die && ! $result) die ("Erreur: $query<br>".mysql_error());
        
        return $result;
    }

    function query_to_obj($query)
    {
        $result = $this->query($query, 0);
        
        if ($result)
        {
            return mysql_fetch_assoc($result);
        }
        
        return null;
    }

    function query_to_array($query)
    {
        $arr = array();
     
        $result = $this->query($query, 0);
        
        while ($result && $row = mysql_fetch_assoc($result))
        {
            $arr[] = $row;
        }
        
        return $arr;
    }

    // Init departements
	function populate_depts()
	{
	    $query = "delete from fzq_departements";
	   
	    mysql_query($query);	
	   
	    $values = "";
	    
        if ($fp = fopen(realpath(dirname(__FILE__)) . "/departements.csv", "r"))
        {
            while ($line = fgets($fp))
            {
                list($num, $nom) = split(";", $line);
                
                if ($num != "" && $nom != "")
                { 
                    $nom = addslashes($nom);
                    
                    if (strlen($num) < 2) $num = "0$num";
                    
                    $values .= ($values == "" ? "" : ",") . "('$num', '$nom')";
                }
            }
            
            @fclose($fp);
        }
        
        if ($values != "")
        {
            $query = "insert into fzq_departements (id, nom) values ".$values;
            
            $result = mysql_query($query);		
        }
	}
	
	function init()
    {
		$this->ajout_desc("Forfait par zone et quantit", "Forfait par zone et quantit", "", 1);
		
		$query = "CREATE TABLE IF NOT EXISTS fzq_departements (
		  id varchar(10) NOT NULL,
		  nom text NOT NULL,
		  PRIMARY KEY  (id)
		) AUTO_INCREMENT=1 ;";
		
		$result = mysql_query($query);		
        	
        $this->populate_depts($cnx);
        
		$query = "CREATE TABLE IF NOT EXISTS fzq_zones (
		  id int(11) NOT NULL auto_increment,
		  nom text NOT NULL,
		  PRIMARY KEY  (id)
		) AUTO_INCREMENT=1 ;";
		
		$result = mysql_query($query);		
		
		$query = "CREATE TABLE IF NOT EXISTS fzq_def_zones (
		  id int(11) NOT NULL auto_increment,
		  id_zone int(11) NOT NULL,
		  departement varchar(10) NOT NULL,
		  PRIMARY KEY  (id),
		  INDEX (id_zone, departement)
		) AUTO_INCREMENT=1 ;";
		
		$result = mysql_query($query);			
		
		$query = "CREATE TABLE IF NOT EXISTS fzq_data (
		  id int(11) NOT NULL auto_increment,
		  id_zone int(11) NOT NULL,
		  quantite_min integer,
		  quantite_max integer,
		  forfait float,
		  surcout_unitaire float,
		  PRIMARY KEY  (id),
          INDEX (id_zone, quantite_min, quantite_max)
		) AUTO_INCREMENT=1 ;";
		
		$result = mysql_query($query);	
        
        // Update 1.1
        $this->query("ALTER TABLE `fzq_departements` CHANGE `id` `id` VARCHAR(10) NOT NULL");  		
        $this->query("ALTER TABLE `fzq_def_zones` CHANGE `departement` `departement` VARCHAR(10) NOT NULL");  		
	}

    function trouver_tarif($quantite, $departement)
    {
		$query = "
            select d.*
            from 
                fzq_data d, fzq_def_zones dz
            where
		         dz.departement = LEFT('".$departement."', LENGTH(dz.departement))
             and
                 d.id_zone = dz.id_zone
             and
                ".$quantite." >= quantite_min
		     and
		         ".$quantite." <= quantite_max";
		
		$result = mysql_query($query);
		
        if ($result && $row = mysql_fetch_assoc($result))
        {
            return floatval($row['forfait']) + $quantite * floatval($row['surcout_unitaire']);
        }
        
        // Nous consulter -> tarif 0
        return 0;
    }
    
    function boucle($texte, $args)
    {
        $boucle = strtolower(lireTag($args, 'boucle'));
        
        switch($boucle)
        {
            case 'zones' :
                return $this->boucleZones($texte, $args);
            break;

            case 'departements' :
                return $this->boucleDepartements($texte, $args);
            break;

            case 'tarifs' :
                return $this->boucleTarifs($texte, $args);
            break;
        }
    }
    
    function boucleZones($texte, $args)
    {
        $id_zone = intval(lireTag($args, 'idzone'));
        
        $where = '';
        
        if ($id_zone != 0)
        {
            $where = " where id = $id_zone";
        }
        
        $infos = $this->query_to_array("select * from fzq_zones $where order by nom");
        
        $res = '';
        
        foreach($infos as $info)
        {
            $tmp = str_replace("#ID", $info['id'], $texte);
            $tmp = str_replace("#NOM", $info['nom'], $tmp);
            
            $res .= $tmp;
        }
        
        return $res;
    }
    
    function boucleDepartements($texte, $args)
    {
        $id_zone = intval(lireTag($args, 'idzone'));
        
        $where = '';
        
        if ($id_zone != 0)
        {
            $where = " dz.id_zone = $id_zone and";
        }
        
        $query = "select d.*
            from 
                fzq_def_zones dz, fzq_departements d
            where
                 $where
		         d.id = dz.departement
             order by
                 d.id";

        $infos = $this->query_to_array($query);
        
        $res = '';
        
        foreach($infos as $info)
        {
            $tmp = str_replace("#NUMERO", $info['id'], $texte);
            $tmp = str_replace("#NOM", $info['nom'], $tmp);
            
            $res .= $tmp;
        }
        
        return $res;
    }
    
    function boucleTarifs($texte, $args)
    {
        $id_zone = intval(lireTag($args, 'idzone'));
        
        $where = '';
        
        if ($id_zone != 0)
        {
            $where = " where id_zone = $id_zone ";
        }
        
		$query = "
            select *
            from 
                fzq_data
            $where
             order by
                quantite_min, quantite_max";
    
        $infos = $this->query_to_array($query);
        
        $res = '';
        
        foreach($infos as $info)
        {
            $tmp = str_replace("#QUANTITEMIN", $info['quantite_min'], $texte);
            $tmp = str_replace("#QUANTITEMAX", $info['quantite_max'], $tmp);
            $tmp = str_replace("#PRIX", $info['forfait'], $tmp);
            $tmp = str_replace("#SURCOUTUNITAIRE", $info['surcout_unitaire'], $tmp);
            
            $res .= $tmp;
        }
        
        return $res;
    }
    
    
    function lister()
    {
		$query = "
            select d.*, de.nom, de.id as no_dep, z.nom as nom_zone
            from 
                fzq_data d, fzq_def_zones dz, fzq_departements de, fzq_zones z
            where
                 d.id_zone = dz.id_zone
             and
                 z.id = dz.id_zone
             and
                 de.id = dz.departement
             order by
                de.nom, d.quantite_min, d.quantite_max";
                
        $result = $this->query($query);
        
        $curr = "";
        $data = "";
        $max = 0;
        
        while ($result && $row = mysql_fetch_assoc($result))
        {
            /*
            tarifs['2A'] = { nom_departement: 'Corse du Sud',
              tarifs: [ {libelle: "De 1  25 bouteilles", prix:"10,50"},
                        {libelle: "De 26  60 bouteilles", prix:"9 + 0,75 par bouteille"},
                        {libelle: "Plus de 60 bouteilles", prix:"Nous consulter"} 
                      ]
            };  
            */
            $dep = $row['no_dep'];
            
            if ($curr != $dep)
            {
                if ($curr != '')
                {
                    $data .= '{libelle: "Plus de '.$max.' bouteilles", prix:"Nous consulter"}';
                    
                    echo $tarif . ", tarifs: [ ".$data ."] };\n";
                }
                
                $tarif = "tarifs['".$dep."'] = { nom_zone: '".$row['nom_zone']."', nom_departement: '".trim(str_replace("'", "\\'", $row['nom']))."'";
                
                $curr = $dep;
                $data = "";
            }
            
            $prix = sprintf("%01.2f", $row['forfait']) . "&euro;";
            
            if ($row['surcout_unitaire'] != 0)
            {
                $prix .= " + " . sprintf("%01.2f", $row['surcout_unitaire']) . "&euro; par bouteille";
            }
            
            $data .= '{ libelle: "De '.$row['quantite_min'].'  '.$row['quantite_max'].' bouteilles", prix: "'.$prix.'" },';
            
            $max = $row['quantite_max'];
        }
        
        if ($curr != '')
        {
            $data .= '{libelle: "Plus de '.$max.' bouteilles", prix:"Nous consulter"}';
            
            echo $tarif . ", tarifs: [".$data ."] };\n";
        }
    }
    
	function calcule()
    {
        $departement = strtoupper(substr($this->cpostal, 0, 2));

        return $this->trouver_tarif($this->nbart, $departement);
	}	
}

if (isset($_REQUEST['test']))
{
$fzq = new ForfaitZoneQuantite();

$fzq->boucleZones("Hello", '');
}

?>
